/* Convert the (modified) output of mod2text back into a Protracker
module. This acts as a filter. azz@josstix.demon.co.uk, Adam Sampson */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct note {
  char name[3];
  unsigned short int period;
} notes[] = {
  "C-1", 856, "C#1", 808, "D-1", 762, "D#1", 720, "E-1", 678, "F-1", 640,
  "F#1", 604, "G-1", 570, "G#1", 538, "A-1", 508, "A#1", 480, "B-1", 453,
  "C-2", 428, "C#2", 404, "D-2", 381, "D#2", 360, "E-2", 339, "F-2", 320,
  "F#2", 302, "G-2", 285, "G#2", 269, "A-2", 254, "A#2", 240, "B-2", 226,
  "C-3", 214, "C#3", 202, "D-3", 190, "D#3", 180, "E-3", 170, "F-3", 160,
  "F#3", 151, "G-3", 143, "G#3", 135, "A-3", 127, "A#3", 120, "B-3", 113,
  "---", 0
};
#define NUMNOTES (sizeof(notes)/sizeof(struct note))

#define BUFSIZE 1024
#define ERROR(c,x) if(c){fprintf(stderr,"%s\n",x);exit(20);}
#define BUFWRITE(x) fwrite(buffer, sizeof(unsigned char), x, stdout);
#define GRAB(x) ((256*hexval(linein+(x))+hexval(linein+(x)+2))/2)
#define POS (linein+6+(11*k))

unsigned char buffer[BUFSIZE], linein[BUFSIZE], s[6], inst;

void huntfor(unsigned char *h) {
  linein[0] = '\0';
  while ((strncmp(linein, h, strlen(h)))||(strlen(linein)<strlen(h))) {
    fgets(linein, BUFSIZE, stdin);
    if (linein[strlen(linein)-1]=='\n') linein[strlen(linein)-1]='\0';
    ERROR(feof(stdin),"Premature end of file");
  };
};

unsigned char hexval(unsigned char *x) {
  unsigned char wub[3];
  unsigned int i;

  strncpy(wub, x, 2); wub[2] = '\0';
  sscanf(wub, "%2x", &i);
  return (unsigned char)i;
};

void main(int argc, char **argv) {
  int i, j, k, l, m;
  unsigned short int kk, numblocks, samplelength[32];
  FILE *f;

  huntfor("Name: ");
  ERROR((strlen(linein)>26),"Name: line too long");
  for (i=0; i<20; i++) {
    if (i<(strlen(linein)-6)) {
      buffer[i] = linein[i+6];
    } else {
      buffer[i] = '\0';
    };
  };
  BUFWRITE(20);

  for (i=1; i<=31; i++) {
    sprintf(s, "S.%02x: ", i);
    huntfor(s);
    for (j=0; j<22; j++) buffer[j] = linein[j+6];
    BUFWRITE(22);
    kk = GRAB(29);
    buffer[0] = kk/256; /* size */
    buffer[1] = kk%256;
    samplelength[i] = kk;
    buffer[2] = hexval(linein+34); /* finetune */
    buffer[3] = hexval(linein+36); /* volume */
    kk = GRAB(39);
    buffer[4] = kk/256; /* loop start */
    buffer[5] = kk%256;
    kk = GRAB(44);
    buffer[6] = kk/256; /* loop period */
    buffer[7] = kk%256;
    BUFWRITE(8);
  };

  huntfor("Play: ");
  buffer[0] = (strlen(linein)-5)/3; /* 5 so you don't need a space at end */
  buffer[1] = 127;
  numblocks = 0;
  for (i=0; i<128; i++) {
    if (i<buffer[0]) {
      buffer[i+2] = hexval(linein + 6 + (i*3));
      if (buffer[i+2]>numblocks) numblocks = buffer[i+2];
    } else {
      buffer[i+2] = 0;
    };
  };
  numblocks++;
  BUFWRITE(130);

  huntfor("Sign: ");
  memcpy(buffer, linein+6, 4);
  BUFWRITE(4);
  for (i=0; i<numblocks; i++) {
    for (j=0; j<=63; j++) {
      sprintf(s, "%02x%02x", i, j);
      huntfor(s);
      for (k=0; k<=3; k++) {
	/* POS is linein+6+(11*k) */
	m = 0;
	for (l=0; l<NUMNOTES; l++) {
	  if (!strncmp(notes[l].name, POS, 3)) m = l;
	};
	buffer[0] = (hexval(POS+4)&0xf0)+(notes[m].period/256);
	buffer[1] = (notes[m].period)&0xff;
	buffer[2] = ((hexval(POS+4)&0x0f)<<4)+hexval(POS+6);
	buffer[3] = hexval(POS+8);
	BUFWRITE(4);
      };
    };
  };

  for (i=1; i<=31; i++) {
    if (samplelength[i]) {
      sprintf(s, "Sd%02x", i);
      huntfor(s);
      if ((f = fopen("t2m.tmp","w"))) {
	while (strncmp(linein, "end", 3)) {
	  fgets(linein, BUFSIZE, stdin);
	  fputs(linein, f);
	};
	fclose(f);
	system("uudecode <t2m.tmp");
	if ((f = fopen("sample_data","r"))) {
	  j = samplelength[i]*2;
	  while(j--)putchar(fgetc(f));
	  fclose(f);
	} else {
	  ERROR(1,"Couldn't open uudecoded sample_data");
	};
	system("rm -f t2m.tmp sample_data");
      } else {
	ERROR(1,"Couldn't open temp file");
      };
    };
  };
};

